#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <stack>
#include <algorithm>

using namespace std;

int find_depth(const string& s, int l, int r)
{
    int curr = 0;
    int ans = 0;

    for (int i = l; i <= r;++i)
    {
        if (s[i] == '(')
        {
            ++curr;
        }
        else
        {
            --curr;
        }

        ans = max(ans, curr);
    }

    return ans;
}

int find_min(const string& s)
{
    stack<int> st;
    vector<pair<int, int>> intervals;

    for (int i = 0; i < s.size(); ++i)
    {
        if (s[i] == '(')
        {
            st.push(i);
        }
        else
        {
            if (!st.empty())
            {
                intervals.push_back(make_pair(st.top(), i));
                st.pop();
            }
        }
    }

    sort(intervals.begin(), intervals.end());

    int ans = 0;
    int curr_end = -1;

    for (int i = 0; i < intervals.size(); ++i)
    {
        if (intervals[i].first > curr_end)
        {
            curr_end = intervals[i].second;
            ans = max(ans, find_depth(s, intervals[i].first, intervals[i].second));
        }
    }

    return ans;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    string s;
    cin >> s;

    int cnt = 0;
    int ans = 0;

    for (int i = 0; i < s.size(); ++i)
    {
        if (s[i] == '(')
        {
            ++cnt;
        }
        else
        {
            --cnt;
        }

        ans = max(ans, abs(cnt));
    }

    cout << find_min(s) << ' ' << ans << endl;

    return 0;
}
