#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <stack>
#include <algorithm>

using namespace std;

int find_depth(const string& s, int l, int r)
{
    int curr = 0;
    int ans = 0;

    for (int i = l; i <= r;++i)
    {
        if (s[i] == '(')
        {
            ++curr;
        }
        else
        {
            --curr;
        }

        ans = max(ans, curr);
    }

    return ans;
}

int find_min(const string& s)
{
    stack<int> st;
    vector<pair<int, int>> intervals;

    for (int i = 0; i < s.size(); ++i)
    {
        if (s[i] == '(')
        {
            st.push(i);
        }
        else
        {
            if (!st.empty())
            {
                intervals.push_back(make_pair(st.top(), i));
                st.pop();
            }
        }
    }

    sort(intervals.begin(), intervals.end());

    int ans = 0;
    int curr_end = -1;

    for (int i = 0; i < intervals.size(); ++i)
    {
        if (intervals[i].first > curr_end)
        {
            curr_end = intervals[i].second;
            ans = max(ans, find_depth(s, intervals[i].first, intervals[i].second));
        }
    }

    return ans;
}

int find_max(const string& s)
{
    stack<int> st;
    vector<pair<int, int>> intervals;

    for (int i = 0; i < s.size(); ++i)
    {
        if (s[i] == '(')
        {
            st.push(i);
        }
        else
        {
            if (!st.empty())
            {
                intervals.push_back(make_pair(st.top(), i));
                st.pop();
            }
        }
    }

    sort(intervals.begin(), intervals.end());

    int curr_end = -1;
    int my_cnt = 0;

    vector<pair<int, int>> compressed;
    vector<int> depths;

    for (int i = 0; i < intervals.size(); ++i)
    {
        if (intervals[i].first > curr_end)
        {
            compressed.push_back(intervals[i]);
            ++my_cnt;
            curr_end = intervals[i].second;
            depths.push_back(find_depth(s, intervals[i].first, intervals[i].second));
        }
    }

    vector<bool> free(s.size() + 5, true);

    for (int i = 0; i < compressed.size(); ++i)
    {
        for (int j = intervals[i].first; j <= intervals[i].second; ++j)
        {
            free[j] = false;
        }
    }

    int open = 0;
    int left_open = 0;
    int left_closed = 0;
    int closed = 0;

    bool has_open = false;
    bool has_closed = false;

    for (int i = 0; i < s.size(); ++i)
    {
        if (free[i] == true)
        {
            if (s[i] == '(')
            {
                has_open = true;
            }
            else
            {
                if (has_open == false)
                {
                    ++left_closed;
                    continue;
                }

                ++closed;
                has_closed = true;
            }
        }
    }

    has_closed = false;
    has_open = false;

    for (int i = s.size() - 1; i >= 0; --i)
    {
        if (free[i] == true)
        {
            if (s[i] == '(')
            {
                if (has_closed == false)
                {
                    ++left_open;
                    continue;
                }

                ++open;
                has_open = true;
            }
            else
            {
                has_closed = true;
            }
        }
    }

    return max(max(left_closed, left_open), max(open, closed) + *max_element(depths.begin(), depths.end()) - 1);
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    string s;
    cin >> s;

    cout << find_min(s) << ' ' << find_max(s) << endl;

    return 0;
}
