#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

const int maxn = 10;

int n;

vector<int> rows[maxn + 10];
unordered_map<string, int> decode;

int curr_code = 0;

int code(string& s)
{
    if (decode.find(s) != decode.end())
    {
        return decode[s];
    }

    decode[s] = ++curr_code;
    return curr_code;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        string com;
        cin >> com;

        rows[i].push_back(code(com));

        int k;
        cin >> k;

        while (k--)
        {
            string s;
            cin >> s;

            rows[i].push_back(code(s));
        }
    }

    vector<int> p;

    for (int i = 1; i <= n; ++i)
    {
        p.push_back(i);
    }

    int ans = 0;
    vector<int> order;

    vector<bool> seen(50, false);

    int set_code = decode["set"];

    do
    {
        for (int i = 1; i <= curr_code; ++i)
        {
            seen[i] = false;
        }

        int cnt = 0;
        bool flag = false;

        for (int i = 0; i < p.size(); ++i)
        {
            int ix = p[i];

            if (rows[ix][0] == set_code)
            {
                seen[rows[ix][1]] = true;

                for (int j = 2; j < rows[ix].size(); ++j)
                {
                    if (seen[rows[ix][j]] == false)
                    {
                        flag = true;
                        break;
                    }

                    ++cnt;
                }
            }
            else
            {
                for (int j = 1; j < rows[ix].size(); ++j)
                {
                    if (seen[rows[ix][j]] == false)
                    {
                        flag = true;
                        break;
                    }
                }
            }
        }

        if (flag == true)
        {
            continue;
        }

        if (ans < cnt)
        {
            ans = cnt;

            if (order.empty())
            {
                for (auto x : p)
                {
                    order.push_back(x);
                }
            }
            else
            {
                for (int i = 0; i < p.size(); ++i)
                {
                    order[i] = p[i];
                }
            }
        }
    } while (next_permutation(p.begin(), p.end()));

    for (auto x : order)
    {
        cout << x << " ";
    }

    cout << endl;

    return 0;
}
