#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

int opening_skobi = 0, closing_skobi = 0;
vector<int> min_pos_op, min_pos_cl;

int cal_min_skobi (int n, string in) {
    int cur_opened = 0, min_skobi = 0;
    for (int i = 0; i < n; i++) {
        if (in[i] == '(') {
            cur_opened++;
        } else {
            if (cur_opened == 0) {
                min_skobi++;
                opening_skobi++;
            } else {
                cur_opened--;
            }
        }
    }
    min_skobi += cur_opened;
    closing_skobi = cur_opened;

    return min_skobi;
}

int cal_min_level (int n, string in){
    int cur_opened = 0;

    for (int i = 0; i < n; i++) {
        if (in[i] == '(') {
            cur_opened++;
        } else {
            if (cur_opened == 0) {
                min_pos_op.push_back(i);
            } else {
                cur_opened--;
            }
        }
    }
    cur_opened = 0;
    int op_c = min_pos_op.size() - 1;
    for (int i = n - 1; i >= 0; i--) {
        if (in[i] == ')') {
            cur_opened--;
        } else {
            if (cur_opened == 0) {
                min_pos_cl.push_back(i);
            } else {
                cur_opened++;
            }
        }
        if (op_c > 0 && min_pos_op[op_c] == i) {
            cur_opened++;
            op_c--;
        }
    }
    sort(min_pos_cl.begin(), min_pos_cl.end());

    int cl_c = 0, level = 1;
    op_c = 0;
    cur_opened = 0;
    for (int i = 0; i < n; i++) {
        if (op_c < min_pos_op.size() && min_pos_op[op_c] == i) {
            op_c++;
            cur_opened++;
            level = max(level, cur_opened);
        }

        if (in[i] == '(') {
            cur_opened++;
            level = max(level, cur_opened);
        } else {
            cur_opened--;
        }

        if (cl_c < min_pos_cl.size() && min_pos_cl[cl_c] == i) {
            cl_c++;
            cur_opened--;
        }
    }
    return level;
}

int cal_max_level (int n, string in) {
    int cur_opened = opening_skobi, level = opening_skobi;
    for (int i = 0; i < n; i++) {
        if (in[i] == '(') {
            cur_opened++;
            level = max(level, cur_opened);
        } else {
            cur_opened--;
        }
    }
    return level;
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    string in;
    cin >> in;
    int n = in.size(), min_skobi = 0;
    min_skobi = cal_min_skobi(n, in);
    cout << cal_min_level(n, in) << " " << cal_max_level(n, in);
}
